-- wummen.lua
-- Specialization for wumme mod
-- by usxi7sd  04 2011
-- LS 2011

wummen = {};

function wummen.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Attachable, specializations);
end;

function wummen:load(xmlFile)
	local Collision1 = {};
	Collision1.collision = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.collision1#collision"));
	Collision1.collisionAttacher = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.collision1#collsionAttacher"));
	Collision1.armAttacher = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.collision1#armAttacher"));
	Collision1.index = 0;
	self.Collision1Base = Collision1;
	self.collisions = true;	
	local Trans1Node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.Trans1#index"));
    if Trans1Node ~= nil then
        self.Trans1 = {};
        self.Trans1.node = Trans1Node;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.Trans1#minTrans"));
        self.Trans1.minTrans = {};
        self.Trans1.minTrans[1] = Utils.getNoNil(x, 0);
        self.Trans1.minTrans[2] = Utils.getNoNil(y, 0);
        self.Trans1.minTrans[3] = Utils.getNoNil(z, 0);
        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.Trans1#maxTrans"));
        self.Trans1.maxTrans = {};
        self.Trans1.maxTrans[1] = Utils.getNoNil(x, 0);
        self.Trans1.maxTrans[2] = Utils.getNoNil(y, 0);
        self.Trans1.maxTrans[3] = Utils.getNoNil(z, 0);
        self.Trans1.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.Trans1#transTime"), 2)*1000;
        self.Trans1.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.Trans1#touchTransLimit"), 10);
    end;
    local i=0;	
	momSoundFile = Utils.getFilename("hammer.wav", self.baseDirectory);
    self.momSoundId = createSample("hammer");
    loadSample(self.momSoundId, momSoundFile, false);	
	self.timeout = 400; -- Zeit in milisekunden
	self.warten = false;	
end;   -- load

function wummen:update(dt)
	local CollisionBase1 = self.Collision1Base;
	setJointFrame(CollisionBase1.index, 0, CollisionBase1.armAttacher);		
    if self.collisions then
		self.collisions = false;		
		local constr = JointConstructor:new();
		constr:setActors(self.rootNode, self.Collision1Base.collision);
		constr:setJointTransforms(self.Collision1Base.armAttacher, self.Collision1Base.collisionAttacher);
		for i=1, 3 do
			constr:setRotationLimit(i-1, 0, 0, 0);
			constr:setTranslationLimit(i-1, true, 0, 0);
		end;
		self.Collision1Base.index = constr:finalize();
	end;
	if self.attacherVehicle ~= nil then
	    if self:getIsActiveForInput() then
			if InputBinding.hasEvent(InputBinding.wumm) then
			    for i=1, 25 do
					local x, y, z = getTranslation(self.Trans1.node);
					local trans = {x,y,z};
					local newTrans = Utils.getMovedLimitedValues(trans, self.Trans1.maxTrans, self.Trans1.minTrans, 3, self.Trans1.transTime, dt, false);
					setTranslation(self.Trans1.node, unpack(newTrans));
				end;
				playSample(self.momSoundId, 0, 1, 0);			
				self.warten = true;
				self.timeout = 400;
			end;
			
			if self.warten then                           
				if self.timeout > 0 then				
					self.timeout = self.timeout - dt;
				else
					self.timeout = 0;
					stopSample(self.momSoundId);
					self.warten = false;                  	
					if not self.warten then
						for i=1, 25 do
							local x, y, z = getTranslation(self.Trans1.node);
							local trans = {x,y,z};
							local newTrans = Utils.getMovedLimitedValues(trans, self.Trans1.maxTrans, self.Trans1.minTrans, 3, self.Trans1.transTime, dt, true);
							setTranslation(self.Trans1.node, unpack(newTrans));
						end;
					end;
				end;				
			end;	
		end;
	end;
end;

function wummen:delete()
end;
function wummen:mouseEvent(posX, posY, isDown, isUp, button)
end;
function wummen:keyEvent(unicode, sym, modifier, isDown)
end;
function wummen:draw()
			g_currentMission:addHelpButtonText(g_i18n:getText("wummtext"), InputBinding.wumm);
end;